#ifndef (Quick) #declare Quick=0; #end

#if (Quick)
  #declare P_Wall1 = pigment { colour rgb <0.9,0.9,0.9> }
  #declare Wall1 = box { <-49.5,0,-1>, <49.5,40,1> pigment { P_Wall1 }}
  #declare Wall2 = box { <-59.5,0,-1>, <59.5,40,1> pigment { P_Wall1 }}
#else
  #declare P_Wall0 = pigment { agate colour_map { [0.0 rgb <1,1,1>][1.0 rgb <0.9,0.9,0.9>] } scale <1,0.2,1> }
  #declare P_Wall1 = pigment { crackle pigment_map { [0.0 P_Wall0][1.0 rgb <0.8,0.8,0.8>] } scale <0.5,5,0.5> }
  #declare P_Wall3 = pigment { agate colour_map { [0.0 rgb <0.9,0.9,0.9>][1.0 rgb <0.8,0.8,0.8>] } scale <1,0.5,1> }
  #declare P_Wall2 = pigment { crackle pigment_map { [0.0 P_Wall3][1.0 rgb <0.7,0.7,0.7>] } scale <0.5,2,0.5> }

  #declare Wall_SquarePanel = union {
    cylinder { <-4.0,-4.0,-1>, <-4.0,-4.0,0>, 0.5 }  cylinder { <-4.0, 4.0,-1>, <-4.0, 4.0,0>, 0.5 }
    cylinder { < 4.0,-4.0,-1>, < 4.0,-4.0,0>, 0.5 }  cylinder { < 4.0, 4.0,-1>, < 4.0, 4.0,0>, 0.5 }
    box { <-4.0,-4.5,-1>,<4.0,4.5,0.001> }           box { <-4.5,-4.0,-1>,<4.5,4.0,0.002> }
  }

  #declare Wall_SquarePanelPierced = difference {
    object { Wall_SquarePanel }
    object { Wall_SquarePanel scale <0.4,0.4,1.0> translate z*-0.75 pigment { P_Wall2 }}
  }

  #declare Wall_TallPanel = union {
    cylinder { <-4.0,-9.0,-1>, <-4.0,-9.0,0>, 0.5 }  cylinder { <-4.0, 9.0,-1>, <-4.0, 9.0,0>, 0.5 }
    cylinder { < 4.0,-9.0,-1>, < 4.0,-9.0,0>, 0.5 }  cylinder { < 4.0, 9.0,-1>, < 4.0, 9.0,0>, 0.5 }
    box { <-4.0,-9.5,-1>,<4.0,9.5,0.001> }           box { <-4.5,-9.0,-1>,<4.5,9.0,0.002> }
  }

  #declare Wall_TallPanelPierced = difference {
    object { Wall_TallPanel }
    object { Wall_TallPanel scale <0.4,0.715789,1.0> translate z*-0.75 pigment { P_Wall2 }}
  }

  #declare Wall_WidePanel = object { Wall_TallPanel rotate z*90 }
  #declare Wall_WidePanelPierced = difference {
    object { Wall_WidePanel }
    object { Wall_WidePanel scale <0.715789,0.4,1.0> translate z*-0.75 pigment { P_Wall2 }}
  }

  #declare Wall1 = union {
    object { Wall_SquarePanelPierced translate <-45, 5,0> }
    object { Wall_SquarePanelPierced translate <-35, 5,0> }
    object { Wall_SquarePanel        translate <-25, 5,0> }
    object { Wall_TallPanel          translate <-15,10,0> }
    object { Wall_SquarePanel        translate < -5, 5,0> }
    object { Wall_SquarePanel        translate <  5, 5,0> }
    object { Wall_TallPanelPierced   translate < 15,10,0> }
    object { Wall_SquarePanelPierced translate < 25, 5,0> }
    object { Wall_SquarePanelPierced translate < 35, 5,0> }
    object { Wall_TallPanel          translate < 45,10,0> }
    object { Wall_SquarePanel        translate <-45,15,0> }
    object { Wall_SquarePanelPierced translate <-35,15,0> }
    object { Wall_SquarePanel        translate <-25,15,0> }
    object { Wall_SquarePanelPierced translate < -5,15,0> }
    object { Wall_SquarePanel        translate <  5,15,0> }
    object { Wall_WidePanelPierced   translate < 30,15,0> }
    object { Wall_SquarePanelPierced translate <-45,25,0> }
    object { Wall_TallPanel          translate <-35,30,0> }
    object { Wall_SquarePanelPierced translate <-25,25,0> }
    object { Wall_SquarePanelPierced translate <-15,25,0> }
    object { Wall_TallPanelPierced   translate < -5,30,0> }
    object { Wall_WidePanelPierced   translate < 10,25,0> }
    object { Wall_SquarePanel        translate < 25,25,0> }
    object { Wall_TallPanelPierced   translate < 35,30,0> }
    object { Wall_SquarePanelPierced translate < 45,25,0> }
    object { Wall_SquarePanelPierced translate <-45,35,0> }
    object { Wall_SquarePanelPierced translate <-25,35,0> }
    object { Wall_SquarePanel        translate <-15,35,0> }
    object { Wall_SquarePanel        translate <  5,35,0> }
    object { Wall_SquarePanelPierced translate < 15,35,0> }
    object { Wall_SquarePanel        translate < 25,35,0> }
    object { Wall_SquarePanel        translate < 45,35,0> }
    box { <-49.5,0,0>, <49.5,40,1> pigment { P_Wall2 }}
    pigment { P_Wall1 }
  }

  #declare Wall2 = union {
    object { Wall_SquarePanelPierced translate <-55, 5,0> }
    object { Wall_SquarePanel        translate <-45, 5,0> }
    object { Wall_SquarePanel        translate <-35, 5,0> }
    object { Wall_TallPanelPierced   translate <-25,10,0> }
    object { Wall_SquarePanel        translate <-15, 5,0> }
    object { Wall_SquarePanel        translate < -5, 5,0> }
    object { Wall_TallPanelPierced   translate <  5,10,0> }
    object { Wall_SquarePanelPierced translate < 15, 5,0> }
    object { Wall_SquarePanel        translate < 25, 5,0> }
    object { Wall_TallPanelPierced   translate < 35,10,0> }
    object { Wall_WidePanelPierced   translate < 50, 5,0> }
    object { Wall_SquarePanel        translate <-55,15,0> }
    object { Wall_SquarePanel        translate <-45,15,0> }
    object { Wall_SquarePanelPierced translate <-35,15,0> }
    object { Wall_SquarePanelPierced translate <-15,15,0> }
    object { Wall_SquarePanelPierced translate < -5,15,0> }
    object { Wall_WidePanelPierced   translate < 20,15,0> }
    object { Wall_SquarePanelPierced translate < 45,15,0> }
    object { Wall_SquarePanel        translate < 55,15,0> }
    object { Wall_SquarePanelPierced translate <-55,25,0> }
    object { Wall_TallPanelPierced   translate <-45,30,0> }
    object { Wall_SquarePanelPierced translate <-35,25,0> }
    object { Wall_SquarePanelPierced translate <-25,25,0> }
    object { Wall_TallPanelPierced   translate <-15,30,0> }
    object { Wall_WidePanelPierced   translate <  0,25,0> }
    object { Wall_SquarePanel        translate < 15,25,0> }
    object { Wall_TallPanelPierced   translate < 25,30,0> }
    object { Wall_WidePanel          translate < 40,25,0> }
    object { Wall_SquarePanelPierced translate < 55,25,0> }
    object { Wall_SquarePanelPierced translate <-55,35,0> }
    object { Wall_WidePanelPierced   translate <-30,35,0> }
    object { Wall_SquarePanelPierced translate < -5,35,0> }
    object { Wall_SquarePanel        translate <  5,35,0> }
    object { Wall_SquarePanelPierced translate < 15,35,0> }
    object { Wall_SquarePanelPierced translate < 35,35,0> }
    object { Wall_WidePanelPierced   translate < 50,35,0> }
    box { <-59.5,0,0>, <59.5,40,1> pigment { P_Wall2 }}
    pigment { P_Wall1 }
  }
#end

#ifndef (FullScene)
  camera { location <0.001,0.001,-100> look_at <0,0,0> }
  light_source { <-500,1000,-2000> colour rgb <1,1,1> }
  object { Wall2 translate y*-20 }
  background { colour rgb <0.25,0.5,1.0> }
#end

